unit FormMain;

interface

uses
  SysUtils, Variants, Classes, QGraphics, QControls, QForms,
  QDialogs, QMenus   , Types, QTypes , Qt ;

type
  TPointWithRange=class;
  TPointLogFile=class;

  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    MnuFile: TMenuItem;
    MnuOpen: TMenuItem;
    MnuClose: TMenuItem;
    MnuLog: TMenuItem;
    MnuSet: TMenuItem;
    MnuCrossColor: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MnuCloseClick(Sender: TObject);
    procedure MnuOpenClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MnuLogClick(Sender: TObject);
    procedure MnuCrossColorClick(Sender: TObject);
  private
    { Private  }
    OriginalImage, ZoomImage, HiddenImage:TBitmap;
    ViewPoint:TPointWithRange;
    RectAllImage:TRect;
    LogFile:TPointLogFile;
    CrossColor:TColor;
    procedure ViewPointChange(Sender:TObject;X,Y:Integer);
    procedure MakeZoomImage;
    procedure DrawCross;
    procedure ChangeRectAllImage;
    procedure Draw;
  public
    { Public  }
  end;

  TOnPointChange=procedure(Sender:TObject;X,Y:Integer) of object;
  { TPointWithRange饹
      ϰ2ɸ
    property X:Integer
      Xɸ
      X[0,XMain]ϰϤȤ
      ͤ0
    property Y:Integer
      Yɸ
      Y[0,YMain]ϰϤȤ
      ͤ0
    property XNain:Integer
      Xɸκ
      ͤ10
    property YMain:Integer
      Yɸκ
      ͤ10}
  TPointWithRange=class(TObject)
  private
    FX,FY:Integer;
    FXMax,FYMax:Integer;
    FOnPointChange:TOnPOintChange;
    procedure SetX(value:Integer);
    procedure SetY(value:Integer);
    procedure SetXMax(value:Integer);
    procedure SetYMax(value:Integer);
  public
    constructor Create;
    property X:Integer read FX write SetX;
    property Y:Integer read FY write SetY;
    property XMax:Integer read FXMax write SetXMax;
    property YMax:Integer read FYMax write SetYMax;
    property OnPointChange:TOnPointChange read FOnPointChange write FOnPointChange;
  end;

  { TPointLogFile饹
      2ɸΥȤ륯饹
    constructor Create(const FileName:string)
      FileNameȤ̾Υե˥Ϥ륤󥹥󥹤ݤ
    procedure Log(APoint:TPointWithRange)
      APointXɸ,Yɸե˽񤭹
      񼰤"Xɸ,Yɸ" }
  TPointLogFile=class(TObject)
  private
    FileStream:TFileStream;
  public
    constructor Create(const FileName:string);
    destructor Destroy; override;
    procedure Log(APoint:TPointWithRange);
  end;

{ funtion BestRect(ClientWidth,ClientHeight,OriginalWidth,OriginalHeight:Integer):Rect
  ClientWidth(),ClientHeight(⤵)ɽΰ
  OriginalWidth(),ClientHeight(⤵)ɽΤ褹
  äȤŬ,ΰRect֤ }
function BestRect(ClientWidth,ClientHeight,OriginalWidth,OriginalHeight:Integer):TRect;

var
  Form1: TForm1;

implementation

const
  ZoomRest   = 10;
  ZoomWidth  =320;
  ZoomCenter =160;
  ZoomPixels = 20;
  labelHeight= 20;
  labelRest  =  2;
  minAllWidth=300;

  type
    T32BitColor = packed record
      R,G,B,Alpha:Byte;
    end;
  const
    Max32BitColorArray = MaxInt div Sizeof(T32BitColor);
  type
    T32BitColorArray = array [0..Max32BitColorArray-1] of T32BitColor;
    P32BitColorArray = ^T32BitColorArray;

{$R *.xfm}
{ TForm1 }
  procedure TForm1.FormCreate(Sender: TObject);
  begin
    { ZoomImageν }
    Self.ZoomImage:=TBitmap.Create;
    with Self.ZoomImage do
    begin
      Width :=ZoomWidth;
      Height:=ZoomWidth;
      PixelFormat:=pf32bit;
    end;
    { βOriginalImageν }
    Self.OriginalImage:=TBitmap.Create;
    Self.OriginalImage.PixelFormat:=pf32bit;
    { ե꡼ν }
    Self.HiddenImage:=TBitmap.Create;
    Self.HiddenImage.Width:=Self.Width;
    Self.HiddenImage.Height:=Self.Height;
    { ViewPointν }
    Self.ViewPoint:=TPointWithRange.Create;
    Self.ViewPoint.OnPointChange:=Self.ViewPointChange;
    Self.ViewPoint.XMax:=0;
    Self.ViewPoint.YMax:=0;
    Self.Width:=Self.Width-Self.ClientWidth+minAllWidth+ZoomRest*2+ZoomWidth;
    Self.Height:=Self.Height-Self.ClientHeight+ZoomRest*2+ZoomWidth;
    { ον }
    Self.CrossColor:=clBlue;
    { ե }
    Self.LogFile:=TPointLogFile.Create(ChangeFileExt(ParamStr(0),'.log'));
  end;

  procedure TForm1.FormDestroy(Sender: TObject);
  begin
    Self.ZoomImage.Free;
    Self.ZoomImage:=nil;
    Self.OriginalImage.Free;
    Self.OriginalImage:=nil;
    Self.HiddenImage.Free;
    Self.HiddenImage:=nil;
    Self.ViewPoint.Free;
    Self.ViewPoint:=nil;
    Self.LogFile.Free;
    Self.LogFile:=nil;
  end;

  procedure TForm1.FormResize(Sender: TObject);
  begin
    if Self.ClientWidth < minAllWidth+ZoomRest*2+ZoomWidth then
    begin
      Self.Width:=Self.Width-Self.ClientWidth+minAllWidth+ZoomRest*2+ZoomWidth;
    end;
    if Self.ClientHeight < ZoomRest*2+ZoomWidth then
    begin
      Self.Height:=Self.Height-Self.ClientHeight+ZoomRest*2+ZoomWidth;
    end;
    { βΰ }
    Self.ChangeRectAllImage;
    Self.Invalidate;
  end;

  procedure TForm1.FormPaint(Sender: TObject);
  begin
    { ե˥ե꡼ }
    Self.Canvas.Draw(0,0,Self.HiddenImage);
  end;

  procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
    Shift: TShiftState; X, Y: Integer);
  begin
    if not(Self.OriginalImage.Empty) and (Button = mbLeft) then
    begin
      if (X <= Self.RectAllImage.Right) and (Y <= Self.RectAllImage.Bottom) then
      begin
        { ɽƤޥαܥǲȤ }
        Self.ViewPoint.X := Trunc(X/Self.RectAllImage.Right *Self.OriginalImage.Width);
        Self.ViewPoint.Y := Trunc(Y/Self.RectAllImage.Bottom*Self.OriginalImage.Height);
      end
      else if (X>=Self.ClientWidth-ZoomRest-ZoomWidth) and (X<Self.ClientWidth-ZoomRest) and (Y>=ZoomRest) and (Y<ZoomWidth+ZoomRest) then
      begin
        { ɽƤޥαܥǲȤ }
        Self.ViewPoint.X:=(X-Self.ClientWidth+ZoomRest+ZoomCenter) div 16 +Self.ViewPoint.X;
        Self.ViewPoint.Y:=(Y-ZoomRest-ZoomCenter) div 16 +Self.ViewPoint.Y;
      end;
    end;
  end;

  procedure TForm1.ViewPointChange(Sender:TObject;X,Y:Integer);
  begin
    { ι }
    Self.MakeZoomImage;
    { ե꡼ }
    Self.Draw;
    Self.Invalidate;
  end;

  procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
    Shift: TShiftState);
  begin
    { ޥΥܥAltƤƤ
      Ƥ뤳Ȥ̵뤹 }
    if ssShift in Shift then
    begin
      { ShiftƤ
        Ʊ¾ΥƤ,줬ͥ褹 }
      case key of
        Key_up   :Self.ViewPoint.Y:=Self.ViewPoint.Y-3;
        Key_down :Self.ViewPoint.Y:=Self.ViewPoint.Y+3;
        Key_left :Self.ViewPoint.X:=Self.ViewPoint.X-3;
        Key_right:Self.ViewPoint.X:=Self.ViewPoint.X+3;
      end;
    end
    else if ssCtrl in Shift then
    begin
      { CtrlƤ
        ƱShiftʳ¾ΥƤ,줬ͥ褹 }
      case key of
        Key_up   :Self.ViewPoint.Y:=Self.ViewPoint.Y-10;
        Key_down :Self.ViewPoint.Y:=Self.ViewPoint.Y+10;
        Key_left :Self.ViewPoint.X:=Self.ViewPoint.X-10;
        Key_right:Self.ViewPoint.X:=Self.ViewPoint.X+10;
      end;
    end
    else
    begin
      { ⲡƤʤ }
      case key of
        Key_up   :Self.ViewPoint.Y:=Self.ViewPoint.Y-1;
        Key_down :Self.ViewPoint.Y:=Self.ViewPoint.Y+1;
        Key_left :Self.ViewPoint.X:=Self.ViewPoint.X-1;
        Key_right:Self.ViewPoint.X:=Self.ViewPoint.X+1;
      end;
    end;
  end;

  procedure TForm1.MakeZoomImage;
  var
    { βγ礹ʬοŪݻ }
    OColor:array[0 .. ZoomPixels-1] of array[0 .. ZoomPixels-1] of T32BitColor;
    Brack:T32BitColor;
    OLIne,ZLine:P32BitColorArray;
    i,j,X,Y:Integer;
  begin
    with Brack do
    begin
      R:=0;
      G:=0;
      B:=0;
      Alpha:=0;
    end;
    { 礹ʬݤ }
    for i:=0 to ZoomPixels-1 do
    begin
      Y:=i+Self.ViewPoint.Y-10;
      if (Y >= 0) and ( Y < Self.ViewPoint.YMax) then
      begin
        { Yϲ }
        OLine:=Self.OriginalImage.ScanLine[Y];
        for j:=0 to ZoomPixels-1 do
        begin
          X:=j+Self.ViewPoint.X-10;
          if (X >= 0) and (X < Self.ViewPoint.XMax) then
          begin
            { Xϲ }
            OColor[j,i]:=OLine^[X];
          end
          else
          begin
            { Xϲγ }
            OColor[j,i]:=Brack;
          end;
        end;
      end
      else
      begin
        { Yϲγ }
        for j:=0 to 19 do
        begin
          OColor[j,i]:=Brack;
        end;
      end;
    end;
    { 礷褹 }
    for i:=0 to ZoomWidth-1 do
    begin
      ZLine:=Self.ZoomImage.ScanLine[i];
      for j:=0 to ZoomWidth-1 do
      begin
        if ((j >= ZoomCenter-2) and (j <= ZoomCenter+1)) or ((i >= ZoomCenter-2) and (i <= ZoomCenter+1)) then
        begin
          { Υ }
          ZLine^[j]:=Brack;
        end
        else
        begin
          ZLine^[j]:=OColor[Trunc(j/16),Trunc(i/16)];
        end;
      end;
    end;
  end;

  procedure TForm1.DrawCross;
  const
    CrossLength=10;
  var
    X,Y:Integer;
  begin
    if not(Self.OriginalImage.Empty) then
    begin
      Self.HiddenImage.Canvas.Pen.Color:=Self.CrossColor;
      X:=Trunc(Self.ViewPoint.X/Self.OriginalImage.Width*Self.RectAllImage.Right);
      Y:=Trunc(Self.ViewPoint.Y/Self.OriginalImage.Height*Self.RectAllImage.Bottom);
      Self.HiddenImage.Canvas.MoveTo(X-CrossLength,Y);
      Self.HiddenImage.Canvas.LineTo(X+CrossLength,Y);
      Self.HiddenImage.Canvas.MoveTo(X,Y-CrossLength);
      Self.HiddenImage.Canvas.LineTo(X,Y+CrossLength);
    end;
  end;

  procedure TForm1.ChangeRectAllImage;
  begin
    if Assigned(Self.OriginalImage) then
    begin
      if not(Self.OriginalImage.Empty) then
      begin
        Self.RectAllImage:=BestRect(Self.ClientWidth-ZoomRest*2-ZoomWidth,Self.ClientHeight-labelHeight,Self.OriginalImage.Width,Self.OriginalImage.Height);
      end;
    end;
    if Assigned(Self.HiddenImage) then
    begin
      { ե꡼ }
      Self.HiddenImage.Width:=Self.Width;
      Self.HiddenImage.Height:=Self.Height;
      { ե꡼ }
      Self.Draw;
    end;
  end;

  procedure TForm1.Draw;
  begin
    { ֥饷 }
    Self.HiddenImage.Canvas.Brush:=Self.Canvas.Brush;
    { طʤɤĤ֤ }
    Self.HiddenImage.Canvas.FillRect(Self.ClientRect);
    { Τβ }
    Self.HiddenImage.Canvas.StretchDraw(Self.RectAllImage,Self.OriginalImage);
    {  }
    Self.HiddenImage.Canvas.Draw(Self.ClientWidth-ZoomRest-ZoomWidth,ZoomRest,Self.ZoomImage);
    { ɸ }
    Self.HiddenImage.Canvas.TextOut(0,Self.ClientHeight-labelHeight+labelRest,Format(' X : %d , Y : %d',[Self.ViewPoint.X,Self.ViewPoint.Y]));
    { Υ }
    Self.DrawCross;
  end;

  procedure TForm1.MnuOpenClick(Sender: TObject);
  var
    OpenDialog:TOpenDialog;
    FileName,Ext:string;
  begin
    OpenDialog:=TOpenDialog.Create(Self);
    try
      OpenDialog.Title:='';
      { ɤ߹μϥӥåȥޥå,JPEG }
      OpenDialog.Filter:='|*.bmp;*.BMP:*.jpeg;*.JPEG;*.jpg;*.JPG';
      if OpenDialog.Execute then
      begin
        FileName:=OpenDialog.FileName;
        Ext:=LowerCase(ExtractFileExt(FileName));
        { եɤ߹ }
        Self.OriginalImage.LoadFromFile(FileName);
        { եॿȥ˥ե̾դä }
        Self.Caption:=Format('Zahyou-%s',[FileName]);
        { ViewPointν }
        Self.ViewPoint.XMax:=Self.OriginalImage.Width;
        Self.ViewPoint.YMax:=Self.OriginalImage.Height;
        { ι }
        Self.MakeZoomImage;
        { βΰ }
        Self.ChangeRectAllImage;
        Self.Invalidate;
      end;
    finally
      OpenDialog.Free;
      OpenDialog:=nil;
    end;
  end;

  procedure TForm1.MnuLogClick(Sender: TObject);
  begin
    Self.LogFile.Log(Self.ViewPoint);
  end;

  procedure TForm1.MnuCloseClick(Sender: TObject);
  begin
    Self.Close;
  end;

  procedure TForm1.MnuCrossColorClick(Sender: TObject);
  var
    ColorDialog:TColorDialog;
  begin
    ColorDialog:=TColorDialog.Create(Self);
    try
      if ColorDialog.Execute then
      begin
        Self.CrossColor:=ColorDialog.Color;
        Self.DrawCross;
        Invalidate;
      end;
    finally
      ColorDialog.Free;
      ColorDialog:=nil;
    end;
  end;

{ TPointWithRange }
  constructor TPointWithRange.Create;
  begin
    Self.FX:=0;
    Self.FY:=0;
    Self.FXMax:=10;
    Self.FYMax:=10;
  end;

  procedure TPointWithRange.SetX(value:Integer);
  begin
    if (value >= 0) and (value <= Self.FXMax) then
    begin
      Self.FX:=value;
      if Assigned(Self.FOnPointChange) then
      begin
        Self.FOnPointChange(Self,Self.FX,Self.FY);
      end;
    end;
  end;

  procedure TPointWithRange.SetY(value:Integer);
  begin
    if (value >= 0) and (value <= Self.FYMax) then
    begin
      Self.FY:=value;
      if Assigned(Self.FOnPointChange) then
      begin
        Self.FOnPointChange(Self,Self.FX,Self.FY);
      end;
    end;
  end;

  procedure TPointWithRange.SetXMax(value:Integer);
  begin
    if value >= 0 then
    begin
      Self.FXMax:=value;
      if Self.FX > value then
      begin
        Self.FX:=value;
      end;
    end;
  end;

  procedure TPointWithRange.SetYMax(value:Integer);
  begin
    if value >= 0 then
    begin
      Self.FYMax:=value;
      if Self.FY > value then
      begin
        Self.FY:=value;
      end;
    end;
  end;

{ TPointLog }
  constructor TPointLogFile.Create(const FileName:string);
  begin
    Self.FileStream:=TFileStream.Create(FileName,fmCreate);
  end;

  destructor TPointLogFile.Destroy;
  begin
    Self.FileStream.Free;
    Self.FileStream:=nil;
  end;

  procedure TPointLogFile.Log(APoint:TPointWithRange);
  var
    S:string;
    B:Byte;
  begin
    S:=Format('%d,%d' ,[APoint.X,APoint.Y]);
    Self.FileStream.Write(Pointer(S)^,Length(S));
    B:=$0D;
    Self.FileStream.Write(B,1);
    B:=$0A;
    Self.FileStream.Write(B,1);
  end;

{ BestRect }
function BestRect(ClientWidth,ClientHeight,OriginalWidth,OriginalHeight:Integer):TRect;
begin
  with Result do
  begin
    Left:=0;
    Top :=0;
  end;
  if ClientWIdth*OriginalHeight > ClientHeight*OriginalWidth then
  begin
    { 褹˲ΰ;餻٤ }
    with Result do
    begin
      Right:=Trunc(ClientHeight*OriginalWidth/OriginalHeight);
      Bottom:=ClientHeight;
    end;
  end
  else
  begin
    { 褹˽Ĥΰ;餻٤ }
    with Result do
    begin
      Right:=ClientWidth;
      Bottom:=Trunc(ClientWidth*OriginalHeight/OriginalWidth);
    end;
  end;
end;

end.
